#include "moodlight1_v2.h"

void ports_init()
{
	DDRB = 0xFF;

	PORTD |= ((1<<PD2) | (1<<PD0));
}

void adc_init()
{	
	//ADC-Channel 0
	ADMUX |= (1<<REFS0);					//Reference is AVCC (5V)
	
	ADCSRA |= (1<<ADEN);					// ADC on
	ADCSRA |= ((1<<ADPS2) | (1<<ADPS1));	// Prescaler = 64 (125 kHz @ 8 MHz)
	ADCSRA |= (1<<ADFR);					// Set ADC to free running mode
	//ADCSRA |= (1<<ADIE);					// activate ADC-Interrupt
	
	ADCSRA |= (1<<ADSC);					// start converting...
}

void interrupt_init()
{
	MCUCR |= (1<<ISC01);
	//GICR |= (1<<INT0);
	sei();
}

void pwm_timer_init()
{
// PWM MODE SELECT
	// Fast PWM, TOP = 0xFF
	TCCR1A |= (1<<WGM10);
	TCCR1B |= (1<<WGM12);

	// Fast PWM, TOP = 0xFF
	TCCR2 |= (1<<WGM20);
	TCCR2 |= (1<<WGM21);


// OUTPUT BEHAVIOR
	// Clear OC1A on Compare Match,
	// Set OC1A at bottom.
	TCCR1A |= (1<<COM1A1);

	// Clear OC1B on Compare Match,
	// Set OC1B at bottom.
	TCCR1A |= (1<<COM1B1);

	// Clear OC2A on Compare Match,
	// Set OC2A at bottom.
	TCCR2 |= (1<<COM21);

	TIMSK |= (1<<TOIE1);

// Prescaler einstellen, Timer(1+2) starten
	//TCCR1B |= (1<<CS11);		// PS = 8
	//TCCR2 |= (1<<CS21);		// PS = 8
	TCCR1B	|= ( (1<<CS11) | (1<<CS10) );	// PS = 64
	TCCR2	|= (1<<CS22);					// PS = 64
}

void uart_init()
{
	// double speed
	UCSRA |= (1<<U2X);
	
	UCSRB = ((1<<RXEN) | (1<<TXEN) | (1<<UCSZ2));

	// asynchrone operation, odd parity, 1 stop bit, 8 data bits
	UCSRC = ((1<<UCSZ1) | (1<<UCSZ0) | (1<<UPM1) | (1<<UPM0));

	// set baud rate
	UBRRH = 0;
	UBRRL = 51;			// 19,2k @ 8MHz @ 2x, 9,6k @ 8MHz @ 1x
}

