#include "moodlight1_v2.h"


unsigned char cosinus[] = {
1,1,1,1,1,1,1,1,
1,2,2,2,2,2,3,3,
3,4,4,4,5,5,5,6,
6,7,7,8,8,9,9,10,
10,11,12,12,13,14,14,15,
16,16,17,18,19,20,20,21,
22,23,24,25,26,27,28,29,
30,31,32,33,34,35,36,37,
38,39,40,41,42,44,45,46,
47,48,50,51,52,53,55,56,
57,58,60,61,62,64,65,66,
68,69,71,72,73,75,76,78,
79,80,82,83,85,86,88,89,
91,92,94,95,97,98,100,101,
103,104,106,107,109,110,112,114,
115,117,118,120,121,123,124,126,
128,129,131,132,134,135,137,138,
140,141,143,145,146,148,149,151,
152,154,155,157,158,160,161,163,
164,166,167,169,170,172,173,175,
176,177,179,180,182,183,184,186,
187,189,190,191,193,194,195,197,
198,199,200,202,203,204,205,207,
208,209,210,211,213,214,215,216,
217,218,219,220,221,222,223,224,
225,226,227,228,229,230,231,232,
233,234,235,235,236,237,238,239,
239,240,241,241,242,243,243,244,
245,245,246,246,247,247,248,248,
249,249,250,250,250,251,251,251,
252,252,252,253,253,253,253,253,
254,254,254,254,254,254,254,254
};

volatile unsigned char mode = 0;
volatile unsigned char Button_Flag = 0;

int delay = 0;

unsigned char pointer_rd;
unsigned char pointer_gn;
unsigned char pointer_bl;
volatile unsigned int ADC_11bit;
volatile unsigned char Index = 0;

unsigned char ee_mode			EEMEM;


//######### Start of subroutine LED_test #########
/*All main color combinations are switched on for a while,
if button is pressed during startup.
If butten is still pressed after all LEDs have been tested,
LEDs stay white and brightness can be set by the poti.*/ 
void LED_test()
{
	// switch through the main combinations, if button is pressed:
	if( !(PIND & (1<<PIND2)) )
	{
		for(unsigned char temp1 = 0; temp1 <= WT; temp1++)
		{
			Set_color(temp1);

			for(unsigned char temp2 = 0; temp2 < 30; temp2++)
			{
				_delay_ms(100);
			}
		}
	}

	// switch to white, if button is still pressed and stay here forever...
	if( !(PIND & (1<<PIND2)) )
	{
		PWM_REG_RD = 128;
		PWM_REG_GN = 128;
		PWM_REG_BL = 128;

		TCCR1B &= 0xF8;
		TCCR1B |= (1<<CS10);

		TCCR2 &= 0xF8;
		TCCR2 |= (1<<CS20);

		while(1)
		{
			Read_ADC();

			PWM_REG_RD = ADC_11bit >> 3;
			PWM_REG_GN = PWM_REG_RD;
			PWM_REG_BL = PWM_REG_GN;

			_delay_ms(20);
		}
	}
	
	Set_color(OFF);
}
//######### END of subroutine LED_test #########



void Wait(unsigned int delay)
{
	unsigned char mode_old = mode;

	for(; ((delay >= 1) && (mode_old == mode)); delay--)
	{
		_delay_ms(1);
	}
}


unsigned char Load_PWM_values(	unsigned char soft_direction,
								unsigned char *array_pointer)
{
	// count up
	if(soft_direction == 1)
	{
		if(*array_pointer < MAX)
		{
			(*array_pointer)++;
		}
	}

	// count down
	else if(soft_direction == 2)
	{
		if(*array_pointer > MIN)
		{
			(*array_pointer)--;
		}
	}

return cosinus[*array_pointer];
}

void Set_color(unsigned char l_color)
{
	if(l_color == RD)
	{
		PWM_REG_RD = MAX;
		PWM_REG_GN = MIN;
		PWM_REG_BL = MIN;
	}

	else if(l_color == YE)
	{
		PWM_REG_RD = MAX;
		PWM_REG_GN = MAX;
		PWM_REG_BL = MIN;
	}

	else if(l_color == GN)
	{
		PWM_REG_RD = MIN;
		PWM_REG_GN = MAX;
		PWM_REG_BL = MIN;
	}

	else if(l_color == CY)
	{
		PWM_REG_RD = MIN;
		PWM_REG_GN = MAX;
		PWM_REG_BL = MAX;
	}

	else if(l_color == BL)
	{
		PWM_REG_RD = MIN;
		PWM_REG_GN = MIN;
		PWM_REG_BL = MAX;
	}
	else if(l_color == MG)
	{
		PWM_REG_RD = MAX;
		PWM_REG_GN = MIN;
		PWM_REG_BL = MAX;
	}

	else if(l_color == WT)
	{
		PWM_REG_RD = MAX;
		PWM_REG_GN = MAX;
		PWM_REG_BL = MAX;
	}

	else
	{
		PWM_REG_RD = MIN;
		PWM_REG_GN = MIN;
		PWM_REG_BL = MIN;
	}
}

unsigned char phasen()
{
//two bits for every color define the fade direction,
//	Bit [1-0]:	red
//	Bit [3-2]:	green
//	Bit [5-4]:	blue
//"0" => nothing (keep PWM value)
//"1" => fade in
//"2" => fade out
	static unsigned char blendphase = 0;

	blendphase++;

	if(blendphase > 7)
	{
		blendphase = 1;
	}

	switch(blendphase)
	{
		case 1:
			return 0b000100;	// red on, green fade in
			break;

		case 2:
			return 0b000010;	// green on, red fade out
			break;

		case 3:
			return 0b010000;	// green on, blue fade in
			break;
		
		case 4:
			return 0b001000;	// blue on, green fade out
			break;
		
		case 5:
			return 0b000001;	// blue on, red fade in
			break;

		case 6:
			return 0b000100;	// blue on, red on, green fade in
			break;

		case 7:
			return 0b101000;	// red on, green and blue fade out
			break;
	}

	return 0;
}
//###################################

int main(void)
{
	OSCCAL = 0xA5;

	ports_init();		
	pwm_timer_init();
	adc_init();
	LED_test();		
	interrupt_init();
	uart_init();

	mode = eeprom_read_byte(&ee_mode);

	if(mode > MODE_MAX)
		mode = 0;

	//##### Start of main infinite loop #####
	while(1)					
	{	
		if(mode == SOFTFADE)
		{
			Soft_fade();
		}

		else if(mode == PHASESHIFT)
		{
			Phaseshift_120_degrees();
		}

		else if(mode == NOFADE)
		{
			No_fade();
		}

		else if(mode == STROBE)
		{
			Strobe();
		}

		else if((mode > STROBE) && (mode < COLOR_SELECT))
		{
			Single_color();
		}

		else if(mode == COLOR_SELECT)
		{
			Color_select();
		}

		else if(mode == SLAVE)
		{
			Slave_mode();
		}
	}
}


//##### Start of subroutine Soft_fade #####
/* Continous fade through the RGB color spectrum,
speed adjustable by the poti.*/
void Soft_fade()
{
	pointer_rd = MAX;
	pointer_gn = MIN;
	pointer_bl = MIN;

	PWM_REG_RD = cosinus[pointer_rd];
	PWM_REG_GN = cosinus[pointer_gn];
	PWM_REG_BL = cosinus[pointer_bl];

	while(mode == SOFTFADE)
	{
		unsigned char l_direction = phasen();

		for(unsigned int l_temp = MIN; (l_temp < MAX) && (mode == SOFTFADE); l_temp++)
		{
			PWM_REG_RD	= Load_PWM_values(  (l_direction	   & 0x03),	(unsigned char*) &pointer_rd);
			PWM_REG_GN	= Load_PWM_values( ((l_direction >> 2) & 0x03),	(unsigned char*) &pointer_gn);
			PWM_REG_BL	= Load_PWM_values( ((l_direction >> 4) & 0x03),	(unsigned char*) &pointer_bl);

			Wait((ADC_11bit >> 6) + 5);
		}
	}
}
//##### END of subroutine soft_fade #####


//##### Start of subroutine Phaseshift_120_degrees #####
/* LEDs are faded like a three phase system with a fixed
phase shift of 120 degrees between the main colors. No pure
colors will be possible, but other color mixes then in mode 1.
speed adjustable by the poti.*/
void Phaseshift_120_degrees()
{
	pointer_rd = MIN;	// 0 degree
	pointer_gn = 170;	// +270 degree (-120 degree)
	pointer_bl = 170;	// +120 degree (-240 degree)

	// red fade in, green fade out, blue fade in
	unsigned char l_direction = 0b00011001;

	PWM_REG_RD = cosinus[pointer_rd];
	PWM_REG_GN = cosinus[pointer_gn];
	PWM_REG_BL = cosinus[pointer_bl];

	while(mode == PHASESHIFT)
	{
		PWM_REG_RD	= Load_PWM_values(  (l_direction	   & 0x03),	(unsigned char*) &pointer_rd);
		PWM_REG_GN	= Load_PWM_values( ((l_direction >> 2) & 0x03),	(unsigned char*) &pointer_gn);
		PWM_REG_BL	= Load_PWM_values( ((l_direction >> 4) & 0x03),	(unsigned char*) &pointer_bl);

		// toggle fade directions at top/bottom
		if(pointer_rd == MAX)
			l_direction ^= 0b00000011;

		else if(pointer_rd == MIN)
			l_direction ^= 0b00000011;

		if(pointer_gn == MAX)
			l_direction ^= 0b00001100;

		else if(pointer_gn == MIN)
			l_direction ^= 0b00001100;

		if(pointer_bl == MAX)
			l_direction ^= 0b00110000;

		else if(pointer_bl == MIN)
			l_direction ^= 0b00110000;

		Wait((ADC_11bit >> 6) + 1);
	}
}
//##### END of subroutine Phaseshift_120_degrees #####


//##### Start of subroutine Color_select #####
/*color values are not faded, but switched hard
from one combination to the next. Speed adjustable
by the poti*/
void No_fade()
{
	while(mode == NOFADE)
	{
		for(unsigned char l_temp = 0; (l_temp <= WT) && (mode == NOFADE); l_temp++)
		{
			Set_color(l_temp);

			Wait(ADC_11bit + 10);
		}
	}
}
//##### END of subroutine no_fade #####






//##### Start of subroutine Strobe #####
/*All three LEDs are flashing for a short moment,
speed is adjusable by the poti.*/
void Strobe()
{	
	while(mode == STROBE)
	{
		Set_color(WT);
		_delay_ms(15);
		
		// if poti is almost at end position, the LEDs stay on
		if(ADC_11bit > 5)
		{
			Set_color(OFF);
			Wait(ADC_11bit + 5);
		}
	}
}
//##### END of subroutine Strobe #####






//##### Start of subroutine Single_color #####
/*The three main colors are faded in an out separatly.
No other effects.*/
void Single_color()
{
	unsigned char l_direction = 1;

	while((mode > STROBE) && (mode < COLOR_SELECT))
	{

		for(unsigned int l_temp = MIN; (l_temp < MAX) && (mode < COLOR_SELECT); l_temp++)
		{
			if(mode == SINGLE_RD)
			{
				PWM_REG_GN = MIN;
				PWM_REG_BL = MIN;		

				PWM_REG_RD = Load_PWM_values(l_direction, (unsigned char*) &pointer_rd);
			}
	//---------------------------

			else if(mode == SINGLE_GN)
			{
				PWM_REG_RD = MIN;
				PWM_REG_BL = MIN;

				PWM_REG_GN = Load_PWM_values(l_direction, (unsigned char*) &pointer_gn);
			}
	//--------------------------

			else if(mode == SINGLE_BL)
			{
				PWM_REG_RD = MIN;
				PWM_REG_GN = MIN;

				PWM_REG_BL = Load_PWM_values(l_direction, (unsigned char*) &pointer_bl);
			}
	//--------------------------
	
			Wait((ADC_11bit >> 6) + 1);
		}

		// toggle fade direction
		l_direction ^= 0x03;
	}

}
//##### END of subroutine Single_color #####





//##### Start of subroutine Color_select #####
/*Color values are directly set by the poti.
Therefor the possible poti value range from 0-2048 
is distributed over the color spectrum from mode 1.*/
void Color_select()
{
	int l_temp = 0;

	while(mode == COLOR_SELECT)
	{	
		l_temp = ADC_11bit;

		if(l_temp >= 1707)
		{
			l_temp -= 1707;

			l_temp = ((3 * l_temp) >> 2);

			PWM_REG_GN = cosinus[(MAX - l_temp)];

			PWM_REG_RD = MAX;
			PWM_REG_BL = MIN;	
		}

		else if((l_temp < 1707) && (l_temp >= 1366))
		{
			l_temp -= 1366;
		
			l_temp = ((3 * l_temp) >> 2);

			PWM_REG_RD = cosinus[l_temp];

			PWM_REG_GN = MAX;
			PWM_REG_BL = MIN;
		}

		else if((l_temp < 1366) && (l_temp >= 1024))
		{
			l_temp -= 1024;
		
			l_temp = ((3 * l_temp) >> 2);

			PWM_REG_BL = cosinus[(MAX - l_temp)];

			PWM_REG_RD = MIN;
			PWM_REG_GN = MAX;
		}

		else if((l_temp < 1024) && (l_temp >= 683))
		{
			l_temp -= 683;
		
			l_temp = ((3 * l_temp) >> 2);

			PWM_REG_GN = cosinus[l_temp];

			PWM_REG_RD = MIN;
			PWM_REG_BL = MAX;
		}

		else if((l_temp < 683) && (l_temp >= 342))
		{
			l_temp -= 342;
		
			l_temp = ((3 * l_temp) >> 2);

			PWM_REG_RD = cosinus[(MAX - l_temp)];

			PWM_REG_GN = MIN;
			PWM_REG_BL = MAX;
		}

		else if(l_temp < 342)
		{
			l_temp = ((3 * l_temp) >> 2);

			PWM_REG_BL = cosinus[l_temp];

			PWM_REG_RD = MAX;
			PWM_REG_GN = MIN;
		}	
	}
}
//##### END des UPs farb_wahl #####


//##### Start subroutine Slave_mode() #####
/* The color codes are received by the UART.
Timer interrupt is deaktivated, UART receive interrupt
is activated. After receiving a color value, the value is
transmitted via the UART to the next slave in the chain.*/
void Slave_mode()
{
	static unsigned char l_Index = 0;

	PWM_REG_RD = MIN;
	PWM_REG_GN = MIN;
	PWM_REG_BL = MIN;

	TIMSK &= ~(1<<TOIE1);
	UCSRB |= (1<<RXCIE);

	while(mode == SLAVE)
	{
		Button();

		if(l_Index != Index)
		{
			l_Index = Index;

			if(Index == 1)
				Send_PWM_Value(PWM_REG_RD, 1);

			else if(Index == 2)
				Send_PWM_Value(PWM_REG_GN, 0);
			
			else if(Index == 3)
				Send_PWM_Value(PWM_REG_BL, 0);
		}
	}

	UCSRB &= ~(1<<RXCIE);
	TIMSK |= (1<<TOIE1);
}




//#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#++#+#+#+#+#+#+
	


void Read_ADC()
{
	// Four conversions are made to run oversampling.
	// creating a "pseudo resolution" of 11 Bit
	static unsigned char l_conversions = 0;
	static unsigned int l_adc_buffer = 0;
	
	l_adc_buffer += ADCW;
	l_conversions++;

	if(l_conversions > 3)
	{
		ADC_11bit = (l_adc_buffer >> 1);
		
		l_adc_buffer = 0;
		l_conversions = 0;
	}
}

void Send_PWM_Value(unsigned char l_data, unsigned char l_index)
{
	/* Wait for empty transmit buffer */
	while ( !( UCSRA & (1<<UDRE)) )
	{
	;
	}
	
	// Reset ninth bit
	UCSRB &= ~(1<<TXB8);

	// set ninth bit according to value of l_index
	if(l_index)
		UCSRB |= (1<<TXB8);

	/* Put data into buffer, sends the data */
	UDR = l_data;
}

void Button()
{
	unsigned char l_Level = 0;
	static unsigned char l_Level_old = 0;
	static unsigned char l_bounce = 0;
	static unsigned char l_delay = 0;
	
	l_Level = !(PIND & (1<<PIND2));

	// wait for end of bouncing and for level change
	if((l_Level_old != l_Level) && (l_bounce == 0))
	{
		l_bounce = 1;
		l_Level_old = l_Level;
		
		// button pressed:
		if(l_Level)
		{
			mode++;
			ADC_11bit = 0;

			if(mode > MODE_MAX)
				mode = 0;
			
			// save actual mode to EEPROM:
			eeprom_write_byte(&ee_mode, mode);
		}
	}
	
	// wait for debouncing...
	if(l_bounce)
	{
		if(l_delay < 30)
			l_delay++;
			
		else
		{
			l_delay = 0;
			l_bounce = 0;
		}
	}			
}

ISR(TIMER1_OVF_vect)
{
	static unsigned char l_temp = 0;

	// fetch new ADC value
	Read_ADC();
	
	// Transmit one color every ISR
	// starting with red (indicated by the 9th bit)
	if(l_temp == 0)
	{
		Send_PWM_Value(PWM_REG_RD, 1);
		l_temp++;
	}

	else if(l_temp == 1)
	{
		Send_PWM_Value(PWM_REG_GN, 0);
		l_temp++;
	}

	else if(l_temp == 2)
	{
		Send_PWM_Value(PWM_REG_BL, 0);
		l_temp = 0;
	}
	//-------------------------------

	Button();
}

ISR(USART_RXC_vect)
{
	char l_status, l_ninth, l_data;

	l_status = UCSRA;				// read status bits
	l_ninth = UCSRB & (1<<RXB8);	// read 9th data bit
	l_data = UDR;					// read other 8 data bits

	// error occured:
	if(l_status & ((1<<FE)|(1<<DOR)|(1<<PE)) )
		Index = 0;

	// no error occured:
	else
	{
		// red has been received
		if(l_ninth)
		{
			Index = 1;
			PWM_REG_RD = l_data;
		}

		// green has been received, if red was received previously
		else if(Index == 1)
		{
			Index = 2;
			PWM_REG_GN = l_data;
		}

		// blue has been received, if green was received previously
		else if(Index == 2)
		{
			Index = 3;
			PWM_REG_BL = l_data;
		}
	}
}








