#include <stdlib.h>
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>

void ports_init();
void interrupt_init();
void adc_init();
void pwm_timer_init();
void uart_init();
void Soft_fade();
void Phaseshift_120_degrees();
void No_fade();
void Strobe();
void Single_color();
void Color_select();
void Slave_mode();
void Wait(unsigned int delay);
void Mode_select();
void Set_color(unsigned char l_color);
void Button();
void Read_ADC();
void Send_PWM_Value(unsigned char l_data, unsigned char l_index);

unsigned char phasen();
unsigned char Load_PWM_values(	unsigned char soft_richtung,
								unsigned char *array_pointer);
#define PWM_REG_RD	OCR1A
#define PWM_REG_GN	OCR1B
#define PWM_REG_BL	OCR2

#define MAX 255
#define MIN 0

enum modes {SOFTFADE, PHASESHIFT, NOFADE, STROBE, SINGLE_RD, SINGLE_GN, SINGLE_BL, COLOR_SELECT, SLAVE};
enum colores {RD, YE, GN, CY, BL, MG, WT, OFF};

#define MODE_MAX	SLAVE

